use serde::Deserialize;
use serde::Serialize;

pub type WebSocketMessage = State;

#[derive(Default, Clone, Debug, Serialize, Deserialize, PartialEq, Eq)]
pub struct State {
    pub achievements: Vec<Achievement>,
    pub milestones: Vec<Milestone>,
}

#[derive(Clone, Debug, Serialize, Deserialize, PartialEq, Eq)]
pub struct Achievement {
    pub goal: String,
    pub completed: bool,
    pub uuid: uuid::Uuid,
}

#[derive(PartialEq, Eq, Debug, Clone, Serialize, Deserialize)]
pub struct CreateAchievement {
    pub goal: String,
}

#[derive(PartialEq, Eq, Debug, Clone, Serialize, Deserialize)]
pub struct ToggleAchievement {
    pub uuid: uuid::Uuid,
}

#[derive(PartialEq, Eq, Debug, Serialize, Clone, Deserialize)]
pub struct DeleteAchievement {
    pub uuid: uuid::Uuid,
}

#[derive(Debug, PartialEq, Eq, Serialize, Clone, Deserialize)]
pub struct Milestone {
    pub goal: usize,
    pub uuid: uuid::Uuid,
}

#[derive(PartialEq, Eq, Debug, Clone, Serialize, Deserialize)]
pub struct CreateMilestone {
    pub goal: usize,
}

#[derive(PartialEq, Eq, Debug, Clone, Serialize, Deserialize)]
pub struct DeleteMilestone {
    pub uuid: uuid::Uuid,
}
